/*
 * UART.c
 *
 *  Created on: 15.03.2012
 *      Author: darkhedie
 */

#include "UART.h"
#include "stm32f10x.h"


#if _USE_VAR
void ItoA( int z, char* Buffer )
{
  int i = 0;
  int j;
  char tmp;
  unsigned u;    // In u bearbeiten wir den Absolutbetrag von z.

    // ist die Zahl negativ?
    // gleich mal ein - hinterlassen und die Zahl positiv machen
    if( z < 0 ) {
      Buffer[0] = '-';
      Buffer++;
      // -INT_MIN ist idR. grer als INT_MAX und nicht mehr
      // als int darstellbar! Man muss daher bei der Bildung
      // des Absolutbetrages aufpassen.
      u = ( (unsigned)-(z+1) ) + 1;
    }
    else {
      u = (unsigned)z;
    }
    // die einzelnen Stellen der Zahl berechnen
    do {
      Buffer[i++] = '0' + u % 10;
      u /= 10;
    } while( u > 0 );

    // den String in sich spiegeln
    for( j = 0; j < i / 2; ++j ) {
      tmp = Buffer[j];
      Buffer[j] = Buffer[i-j-1];
      Buffer[i-j-1] = tmp;
    }
    Buffer[i] = '\0';
}
#endif
/*
void uart_init_interrupt(unsigned char ucMode)
{
	switch (ucMode) {
		case RX:
			UCSR0B |= (1<<RXEN0)|(1<<RXCIE0);  // UART RX / RX Interrupt einschalten
			break;
		case CLR:
			UCSR0B &= ~(1<<RXCIE0);  // UART RX / RX Interrupt einschalten
			break;
	}
}*/

void lib_uart_init(void)
{

	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;


	//Configure USART2 Tx as alternate function push-pull
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	USART_InitStructure.USART_BaudRate = 38400;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl =  USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);
	USART_Cmd(USART1, ENABLE);

}

#if _USE_PUTCHAR
void uart_putc(unsigned char c)
{
	USART_SendData(USART1, (unsigned char) c);
	while(USART_GetFlagStatus(USART1,USART_FLAG_TXE) == RESET);	//Warten bis gesendet
}
#endif

#if _USE_PUTSTRING
/* puts ist unabhaengig vom Controllertyp */
void uart_puts (char *s)
{
    while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen(Terminator)" */
        uart_putc(*s);
        s++;
    }
}

/* puts ist unabhaengig vom Controllertyp */
void uart_puts_size (char *s, unsigned int size)
{
    while (size--)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen(Terminator)" */
        uart_putc(*s);
        s++;
    }
}
#endif

#if _USE_HEX
void SendNibble(unsigned char Nibble)
{
   // Preserve range
   Nibble &= 0x0F;
   uart_putc(Nibble <= 9 ? '0'+Nibble : 'A'+Nibble-10);
}

void uart_send_as_hex(unsigned char ucNumber)
{
	// Send upper nibble
    SendNibble(ucNumber >> 4);
    // Send lower nibble
    SendNibble(ucNumber);
}
#endif


#if _USE_VAR
void uart_send_var(unsigned char ucNumber)
{
	char cBuffer[5];
	ItoA(ucNumber,cBuffer);
	uart_puts(cBuffer);
}
#endif

#if _USE_GETCHAR
unsigned char uart_getc(void)
{
    //while (!(UCSR0A & (1<<RXC0)));   // warten bis Zeichen verfuegbar
    //return UDR0;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}
#endif



